#include<assert.h>

#ifndef MAX
#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define MIN(A, B) ((A) < (B) ? (A) : (B))
#endif

class Registry {
 public:
  Registry(int size);
  ~Registry();

  int Register(Token *);
  int Register(Token *, int);
  int find(Token *);
  Token *translate(int);
  int next();
  void reset();
  int count();

 private:
  Token **array;
  int max_size;
  int current_size;
  int marker;
};

